// module clsocket.h
// Copyright Dr.E.Huckert 01-2001
// Versions:
//   2003-06-08 function set_timeout() added

#ifndef CLIENT_SOCKET_DEFINED
#define CLIENT_SOCKET_DEFINED

#ifdef WIN32
#include <io.h>
#include <windows.h>
#include <winsock.h>
#else
#define SOCKET    int
#endif

#define LENGTH_LENGTH    6

class MSGSOCKET;

class CLIENT_SOCKET
{
private:
  SOCKET handle;
  char   inetaddr[32];
  long   timeout_ms;
  int    initialized;
  int    logging;
#ifdef WIN32
  int     wsa_ok;
  WSADATA WSAdata;
#endif
public:
  CLIENT_SOCKET();
  ~CLIENT_SOCKET();
  SOCKET open(const char *hostname, int portnumber);
  void   close();
  SOCKET get_handle()
  {  return this->handle; };
  int    milli_sleep(int ms);
  int    basic_send(char *buf, int lbuf);
  int    send(MSGSOCKET *pmsg, int wait_flag);
  MSGSOCKET *recv();
  int    basic_receive(char *buf, int lbuf, int get_all);
  int    receive_line(char *buf, int lbuf);
  char   *convert_binary_ip(char *binaddr);
  void   set_logging(int flag);
  void   set_timeout(int secs);
};

#define TIMEOUT_SECS    10   // receive timeout in seconds

#endif

