// module msgsocket.cpp
// Private Copyright Dr.E.Huckert 10-1998
// Version  12-12-2002 made ready for binary data

#include <iostream.h>
#include <string.h>
#include <stdlib.h>
#include "msgsocket.h"

// versions
//   2003-05-01 added set_content_length()
//              added is_binary()


// Constructor (for binary data)
MSGSOCKET::MSGSOCKET(char op, char *con, long lcon)
{
  this->content = new char[lcon + 1];
  if (con != NULL)
     memcpy(this->content, con, lcon);
  else
     memset(this->content, 0, lcon + 1);
  this->operation = op;
  this->lcontent  = lcon;
  this->binary    = 1;
}

// Constructor (for non binary data only)
MSGSOCKET::MSGSOCKET(char op, char *con)
{
  this->content = new char[strlen(con) + 1];
  strcpy(this->content, con);
  this->operation = op;
  this->lcontent  = strlen(con);
  this->binary    = 0;
}

// Destructor
MSGSOCKET::~MSGSOCKET()
{
  if (this->content != NULL)
    delete this->content;
}

// Parse a byte stream and fill the message structure from this stream
// The byte stream is field structured
// Returns: the number of  scanned bytes
int MSGSOCKET::parse_and_fill(char *src,
                           long lsrc)
{
  this->operation = src[0];
  if (this->content != NULL)
    delete this->content;
  this->content = new char[lsrc];
  strncpy(this->content, &src[1], lsrc - 1);
  this->content[lsrc - 1] = 0;

  return 0;
}   // end MSGSOCKET::parse_and_fill() 

// Parse a string and return the desired field content
// returns: the number of extracted characters
//          the returned content (retbuf) is zero terminated
int MSGSOCKET::get_field(char  *buf, 
                       int   no_field,   // from 0 on
                       char  *retbuf,   // return buffer
                       int   lretbuf,
                       char  sep)       // field separator character  
{
int  m, n, nof;
  m   = 0;
  nof = 0;
  for (n=0; buf[n] != 0; n++)
  {
    if (buf[n] == sep)
    {
      retbuf[m] = 0;
      nof++;
      if (nof > no_field) 
      {
        return m;
      }
      m = 0;
    }
    else
    {
      if (m < (lretbuf - 1))
        retbuf[m++] = buf[n];
    }
  }
  return 0;
}   // end MSGSOCKET::get_field()

// flatten a message into a string
char *MSGSOCKET::flatten()
{
unsigned long ll;
char          *pret;
  ll      = this->get_content_length();
  pret    = new char[ll + 2];
  pret[0] = this->get_operation();
  strncpy(&pret[1], this->content, ll);
  pret[ll + 1] = 0;
  return pret;
}   // end MSGSOCKET::flatten()

