// module srvsocket.h
// Copyright Dr.E.Huckert 10-1998

#ifndef SRVSOCKET_DEFINED
#define SRVSOCKET_DEFINED

#include <string.h>

#ifdef WIN32
#include <windows.h>
#include <winsock.h>
#else
#define SOCKET int 
#define INVALID_SOCKET    -1
#endif

// the length of the length field before the message data
#define LENGTH_LENGTH 6

class MSGSOCKET;

class SRVSOCKET
{
private:
  SOCKET  listen_sockfd;
  SOCKET  rw_sockfd;
  long    timeout_ms;
  int     sleep_unit;
  int     partial;
  int     logging;
#ifdef WIN32
  int     wsa_ok;
  WSADATA WSAdata;
#endif
public:
  SRVSOCKET();
  SRVSOCKET(SOCKET listen_sockfd, SOCKET rw_sockfd);
  ~SRVSOCKET();
  void basic_init();
  int  open(int port);
  int  close();
  int  close_rwsocket();
  int  status();
  //int  test_socket();                 // problems under Windows
  long basic_send(char *buf, long lbuf);
  int  send(MSGSOCKET *pmsg, int wait_flag);
  long basic_receive(char *buf, long lbuf);
  void set_timeout(long milli_seconds);
  MSGSOCKET *recv();
  int  milli_sleep(int ms);
  void setLogging(int log_flag);
  int  getLogging();
};

#endif

